unit utils;

interface

uses md5;

const hash_size = 32;

type TMyMD5=class(TMD5)
       procedure addCustomStream(filename:string);
     end;

implementation

uses sysutils;

Procedure TMyMD5.AddCustomStream (filename: String);
Const
  ChunkSize = 8192;
var
  Buf: array[1..ChunkSize] of byte;
  count,total,i:integer;
  f:file;
Begin
  Try
    filemode:=fmopenread;
    assignfile(f,filename);
    system.reset(f,1);
    Try
      total:=0;
      while (not eof(f)) and (total+hash_size<filesize(f)) do
      begin
        if total+hash_size+chunksize<=filesize(f) then blockread(f,buf,chunksize,count)
                                                  else blockread(f,buf,filesize(f)-total-hash_size,count);
        for i:=1 to count do
          add(buf[i]);
//        update(buf,count);
        total:=total+count;
      end;
      assert(total=filesize(f)-hash_size);
    Finally
      closefile(f);
    End;
  except
    on e:exception do
      raise Exception.create('error: '+e.message);
  End;
  filemode:=fmOpenReadWrite;// restore
End;

end.
